# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'AppConnectionApplicationEndpoint',
    'AppConnectionGateway',
    'AppConnectorPrincipalInfo',
    'AppConnectorPrincipalInfoServiceAccount',
    'AppGatewayAllocatedConnection',
    'GetAppConnectionApplicationEndpointResult',
    'GetAppConnectionGatewayResult',
    'GetAppConnectorPrincipalInfoResult',
    'GetAppConnectorPrincipalInfoServiceAccountResult',
    'GetAppGatewayAllocatedConnectionResult',
]

@pulumi.output_type
class AppConnectionApplicationEndpoint(dict):
    def __init__(__self__, *,
                 host: str,
                 port: int):
        """
        :param str host: Hostname or IP address of the remote application endpoint.
        :param int port: Port of the remote application endpoint.
               
               - - -
        """
        AppConnectionApplicationEndpoint._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            host=host,
            port=port,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             host: Optional[str] = None,
             port: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if host is None:
            raise TypeError("Missing 'host' argument")
        if port is None:
            raise TypeError("Missing 'port' argument")

        _setter("host", host)
        _setter("port", port)

    @property
    @pulumi.getter
    def host(self) -> str:
        """
        Hostname or IP address of the remote application endpoint.
        """
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def port(self) -> int:
        """
        Port of the remote application endpoint.

        - - -
        """
        return pulumi.get(self, "port")


@pulumi.output_type
class AppConnectionGateway(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "appGateway":
            suggest = "app_gateway"
        elif key == "ingressPort":
            suggest = "ingress_port"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AppConnectionGateway. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AppConnectionGateway.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AppConnectionGateway.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 app_gateway: str,
                 ingress_port: Optional[int] = None,
                 type: Optional[str] = None,
                 uri: Optional[str] = None):
        """
        :param str app_gateway: AppGateway name in following format: projects/{project_id}/locations/{locationId}/appgateways/{gateway_id}.
        :param int ingress_port: (Output)
               Ingress port reserved on the gateways for this AppConnection, if not specified or zero, the default port is 19443.
        :param str type: The type of hosting used by the gateway. Refer to
               https://cloud.google.com/beyondcorp/docs/reference/rest/v1/projects.locations.appConnections#Type_1
               for a list of possible values.
        :param str uri: (Output)
               Server-defined URI for this resource.
        """
        AppConnectionGateway._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            app_gateway=app_gateway,
            ingress_port=ingress_port,
            type=type,
            uri=uri,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             app_gateway: Optional[str] = None,
             ingress_port: Optional[int] = None,
             type: Optional[str] = None,
             uri: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if app_gateway is None and 'appGateway' in kwargs:
            app_gateway = kwargs['appGateway']
        if app_gateway is None:
            raise TypeError("Missing 'app_gateway' argument")
        if ingress_port is None and 'ingressPort' in kwargs:
            ingress_port = kwargs['ingressPort']

        _setter("app_gateway", app_gateway)
        if ingress_port is not None:
            _setter("ingress_port", ingress_port)
        if type is not None:
            _setter("type", type)
        if uri is not None:
            _setter("uri", uri)

    @property
    @pulumi.getter(name="appGateway")
    def app_gateway(self) -> str:
        """
        AppGateway name in following format: projects/{project_id}/locations/{locationId}/appgateways/{gateway_id}.
        """
        return pulumi.get(self, "app_gateway")

    @property
    @pulumi.getter(name="ingressPort")
    def ingress_port(self) -> Optional[int]:
        """
        (Output)
        Ingress port reserved on the gateways for this AppConnection, if not specified or zero, the default port is 19443.
        """
        return pulumi.get(self, "ingress_port")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        The type of hosting used by the gateway. Refer to
        https://cloud.google.com/beyondcorp/docs/reference/rest/v1/projects.locations.appConnections#Type_1
        for a list of possible values.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def uri(self) -> Optional[str]:
        """
        (Output)
        Server-defined URI for this resource.
        """
        return pulumi.get(self, "uri")


@pulumi.output_type
class AppConnectorPrincipalInfo(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "serviceAccount":
            suggest = "service_account"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AppConnectorPrincipalInfo. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AppConnectorPrincipalInfo.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AppConnectorPrincipalInfo.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 service_account: 'outputs.AppConnectorPrincipalInfoServiceAccount'):
        """
        :param 'AppConnectorPrincipalInfoServiceAccountArgs' service_account: ServiceAccount represents a GCP service account.
               Structure is documented below.
        """
        AppConnectorPrincipalInfo._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            service_account=service_account,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             service_account: Optional['outputs.AppConnectorPrincipalInfoServiceAccount'] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if service_account is None and 'serviceAccount' in kwargs:
            service_account = kwargs['serviceAccount']
        if service_account is None:
            raise TypeError("Missing 'service_account' argument")

        _setter("service_account", service_account)

    @property
    @pulumi.getter(name="serviceAccount")
    def service_account(self) -> 'outputs.AppConnectorPrincipalInfoServiceAccount':
        """
        ServiceAccount represents a GCP service account.
        Structure is documented below.
        """
        return pulumi.get(self, "service_account")


@pulumi.output_type
class AppConnectorPrincipalInfoServiceAccount(dict):
    def __init__(__self__, *,
                 email: str):
        """
        :param str email: Email address of the service account.
               
               - - -
        """
        AppConnectorPrincipalInfoServiceAccount._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            email=email,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             email: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if email is None:
            raise TypeError("Missing 'email' argument")

        _setter("email", email)

    @property
    @pulumi.getter
    def email(self) -> str:
        """
        Email address of the service account.

        - - -
        """
        return pulumi.get(self, "email")


@pulumi.output_type
class AppGatewayAllocatedConnection(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ingressPort":
            suggest = "ingress_port"
        elif key == "pscUri":
            suggest = "psc_uri"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in AppGatewayAllocatedConnection. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        AppGatewayAllocatedConnection.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        AppGatewayAllocatedConnection.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ingress_port: Optional[int] = None,
                 psc_uri: Optional[str] = None):
        """
        :param int ingress_port: The ingress port of an allocated connection.
        :param str psc_uri: The PSC uri of an allocated connection.
        """
        AppGatewayAllocatedConnection._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ingress_port=ingress_port,
            psc_uri=psc_uri,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ingress_port: Optional[int] = None,
             psc_uri: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if ingress_port is None and 'ingressPort' in kwargs:
            ingress_port = kwargs['ingressPort']
        if psc_uri is None and 'pscUri' in kwargs:
            psc_uri = kwargs['pscUri']

        if ingress_port is not None:
            _setter("ingress_port", ingress_port)
        if psc_uri is not None:
            _setter("psc_uri", psc_uri)

    @property
    @pulumi.getter(name="ingressPort")
    def ingress_port(self) -> Optional[int]:
        """
        The ingress port of an allocated connection.
        """
        return pulumi.get(self, "ingress_port")

    @property
    @pulumi.getter(name="pscUri")
    def psc_uri(self) -> Optional[str]:
        """
        The PSC uri of an allocated connection.
        """
        return pulumi.get(self, "psc_uri")


@pulumi.output_type
class GetAppConnectionApplicationEndpointResult(dict):
    def __init__(__self__, *,
                 host: str,
                 port: int):
        GetAppConnectionApplicationEndpointResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            host=host,
            port=port,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             host: Optional[str] = None,
             port: Optional[int] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if host is None:
            raise TypeError("Missing 'host' argument")
        if port is None:
            raise TypeError("Missing 'port' argument")

        _setter("host", host)
        _setter("port", port)

    @property
    @pulumi.getter
    def host(self) -> str:
        return pulumi.get(self, "host")

    @property
    @pulumi.getter
    def port(self) -> int:
        return pulumi.get(self, "port")


@pulumi.output_type
class GetAppConnectionGatewayResult(dict):
    def __init__(__self__, *,
                 app_gateway: str,
                 ingress_port: int,
                 type: str,
                 uri: str):
        GetAppConnectionGatewayResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            app_gateway=app_gateway,
            ingress_port=ingress_port,
            type=type,
            uri=uri,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             app_gateway: Optional[str] = None,
             ingress_port: Optional[int] = None,
             type: Optional[str] = None,
             uri: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if app_gateway is None and 'appGateway' in kwargs:
            app_gateway = kwargs['appGateway']
        if app_gateway is None:
            raise TypeError("Missing 'app_gateway' argument")
        if ingress_port is None and 'ingressPort' in kwargs:
            ingress_port = kwargs['ingressPort']
        if ingress_port is None:
            raise TypeError("Missing 'ingress_port' argument")
        if type is None:
            raise TypeError("Missing 'type' argument")
        if uri is None:
            raise TypeError("Missing 'uri' argument")

        _setter("app_gateway", app_gateway)
        _setter("ingress_port", ingress_port)
        _setter("type", type)
        _setter("uri", uri)

    @property
    @pulumi.getter(name="appGateway")
    def app_gateway(self) -> str:
        return pulumi.get(self, "app_gateway")

    @property
    @pulumi.getter(name="ingressPort")
    def ingress_port(self) -> int:
        return pulumi.get(self, "ingress_port")

    @property
    @pulumi.getter
    def type(self) -> str:
        return pulumi.get(self, "type")

    @property
    @pulumi.getter
    def uri(self) -> str:
        return pulumi.get(self, "uri")


@pulumi.output_type
class GetAppConnectorPrincipalInfoResult(dict):
    def __init__(__self__, *,
                 service_accounts: Sequence['outputs.GetAppConnectorPrincipalInfoServiceAccountResult']):
        GetAppConnectorPrincipalInfoResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            service_accounts=service_accounts,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             service_accounts: Optional[Sequence['outputs.GetAppConnectorPrincipalInfoServiceAccountResult']] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if service_accounts is None and 'serviceAccounts' in kwargs:
            service_accounts = kwargs['serviceAccounts']
        if service_accounts is None:
            raise TypeError("Missing 'service_accounts' argument")

        _setter("service_accounts", service_accounts)

    @property
    @pulumi.getter(name="serviceAccounts")
    def service_accounts(self) -> Sequence['outputs.GetAppConnectorPrincipalInfoServiceAccountResult']:
        return pulumi.get(self, "service_accounts")


@pulumi.output_type
class GetAppConnectorPrincipalInfoServiceAccountResult(dict):
    def __init__(__self__, *,
                 email: str):
        GetAppConnectorPrincipalInfoServiceAccountResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            email=email,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             email: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if email is None:
            raise TypeError("Missing 'email' argument")

        _setter("email", email)

    @property
    @pulumi.getter
    def email(self) -> str:
        return pulumi.get(self, "email")


@pulumi.output_type
class GetAppGatewayAllocatedConnectionResult(dict):
    def __init__(__self__, *,
                 ingress_port: int,
                 psc_uri: str):
        GetAppGatewayAllocatedConnectionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            ingress_port=ingress_port,
            psc_uri=psc_uri,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             ingress_port: Optional[int] = None,
             psc_uri: Optional[str] = None,
             opts: Optional[pulumi.ResourceOptions] = None,
             **kwargs):
        if ingress_port is None and 'ingressPort' in kwargs:
            ingress_port = kwargs['ingressPort']
        if ingress_port is None:
            raise TypeError("Missing 'ingress_port' argument")
        if psc_uri is None and 'pscUri' in kwargs:
            psc_uri = kwargs['pscUri']
        if psc_uri is None:
            raise TypeError("Missing 'psc_uri' argument")

        _setter("ingress_port", ingress_port)
        _setter("psc_uri", psc_uri)

    @property
    @pulumi.getter(name="ingressPort")
    def ingress_port(self) -> int:
        return pulumi.get(self, "ingress_port")

    @property
    @pulumi.getter(name="pscUri")
    def psc_uri(self) -> str:
        return pulumi.get(self, "psc_uri")


